<?php
class SampleFieldModelEventListener extends BcModelEventListener {
	
	public $events = array(
		'Blog.BlogPost.afterSave',
		'Blog.BlogPost.beforeFind'
	);

	public function blogBlogPostAfterSave(CakeEvent $event) {
		// 呼び出し元のモデルを取得
		$BlogPost = $event->subject();
		// 保存が完了したブログ記事データを取得
		$data = $BlogPost->data;
		// ブログのプライマリーキーを外部キーとして設定
		$data['SampleField']['blog_post_id'] = $data['BlogPost']['id'];
		// SampleField モデルを初期化
		$SampleField = ClassRegistry::init('SampleField.SampleField');
		// データベースに保存
		$SampleField->save($data['SampleField']);
		return true;
	}
	
	public function blogBlogPostBeforeFind(CakeEvent $event) {
		// 呼び出し元のモデルを取得
		$BlogPost = $event->subject();
		// BlogPost に SampleField を１対１の関係で関連づける
		$BlogPost->bindModel(array('hasOne' => array(
			'SampleField' => array(
				'className' => 'SampleField.SampleField',
				'foreignKey' => 'blog_post_id',
			)
		)), false);	
	}
	
}